> ## Documentation Index
> Fetch the complete documentation index at: https://docs.allium.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Fetch latest fungible token balances

> Get the latest balances for a list of wallets.

export const SupportedChainsList = props => {
  const [data, setData] = useState(null);
  const [isLoading, setIsLoading] = useState(true);
  useEffect(() => {
    const fetchData = async () => {
      try {
        const response = await fetch("https://api.allium.so/api/v1/supported-chains/realtime-apis", {
          method: "GET"
        });
        if (!response.ok) {
          throw new Error(`HTTP error! status: ${response.status}`);
        }
        const responseData = await response.json();
        const filteredData = responseData.filter(entry => {
          const product = entry.endpoints[props.product_name];
          return product !== null;
        });
        setData(filteredData);
        setIsLoading(false);
      } catch (error) {
        setIsLoading(false);
      }
    };
    fetchData();
  }, []);
  if (isLoading) {
    return <div>Loading chain information...</div>;
  }
  if (!data) {
    return <div>No data available</div>;
  }
  const isCustomSQL = props.product_name === "custom_sql";
  return <div>
            {data.length > 0 && <table className="w-full">
                    <thead>
                        <tr>
                            <th>Chain</th>
                            <th>Chain ID</th>
                            <th>Status</th>
                            {isCustomSQL && <th>Tables</th>}
                        </tr>
                    </thead>
                    <tbody>
                        {data.map(chain => {
    const endpoint = chain.endpoints[props.product_name];
    return <tr key={chain.id}>
                                    <td style={{
      padding: '12px'
    }}>{chain.label}</td>
                                    <td style={{
      padding: '12px'
    }}><code>{chain.id}</code></td>
                                    <td style={{
      padding: '12px'
    }}>{endpoint ? endpoint.availability === "beta" ? "🌱 Beta" : "✅ Supported" : "❌ Not Supported"}</td>
                                    {isCustomSQL && <td style={{
      padding: '12px'
    }}>
                                            {endpoint && endpoint.tables ? endpoint.tables.map(t => t.name).join(", ") : "-"}
                                        </td>}
                                </tr>;
  })}
                    </tbody>
                </table>}
        </div>;
};

**Supported Chains**

<SupportedChainsList product_name="latest_fungible_token_balances" />


## OpenAPI

````yaml /_openapi/balances-api.json POST /api/v1/developer/wallet/balances
openapi: 3.1.0
info:
  title: Allium API
  version: 0.1.0
servers:
  - url: https://api.allium.so
security: []
paths:
  /api/v1/developer/wallet/balances:
    post:
      tags:
        - BALANCES
        - DEVELOPER
        - WALLET
      summary: Latest Fungible Token Balances
      description: Get the latest balances for a list of wallets.
      operationId: get_latest_balances_api_v1_developer_wallet_balances_post
      parameters:
        - name: with_liquidity_info
          in: query
          required: false
          schema:
            type: boolean
            description: >-
              If true, returns total_liquidity_usd as well. See [this
              page](https://docs.allium.so/api/developer/data-tips#token-liquidity-filtering)
              for more details.
            default: false
            title: With Liquidity Info
          description: >-
            If true, returns total_liquidity_usd as well. See [this
            page](https://docs.allium.so/api/developer/data-tips#token-liquidity-filtering)
            for more details.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: array
              items:
                $ref: '#/components/schemas/PayloadAddress'
              minItems: 1
              maxItems: 100
              description: List of wallet chain+address pairs to get balances for.
              examples:
                - chain: ethereum
                  address: '0xab16781a13fe343a275f4bb5c883a64ceda52917'
              title: Addresses
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WalletLatestBalancesNewEnvelope'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyBearer: []
components:
  schemas:
    PayloadAddress:
      properties:
        chain:
          type: string
          title: Chain
          description: Lowercase chain name
        address:
          type: string
          title: Address
          description: Wallet address
      type: object
      required:
        - chain
        - address
      title: PayloadAddress
    WalletLatestBalancesNewEnvelope:
      properties:
        items:
          items:
            anyOf:
              - $ref: '#/components/schemas/EVMWalletBalances'
              - $ref: '#/components/schemas/SolanaBalances'
              - $ref: '#/components/schemas/BitcoinBalances'
              - $ref: '#/components/schemas/NearWalletBalances'
              - $ref: '#/components/schemas/SuiWalletLatestBalances'
          type: array
          title: Items
          description: Token balance entries
        cursor:
          anyOf:
            - type: string
            - type: 'null'
          title: Cursor
          description: Pagination cursor for next page
      type: object
      required:
        - items
      title: WalletLatestBalancesNewEnvelope
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    EVMWalletBalances:
      properties:
        chain:
          type: string
          title: Chain
          description: Lowercase chain name
        address:
          $ref: '#/components/schemas/EVMAddress'
          description: Wallet address
        token:
          $ref: '#/components/schemas/Token'
          description: Token metadata
        raw_balance:
          type: integer
          title: Raw Balance
          description: Raw balance of the token
        raw_balance_str:
          type: string
          title: Raw Balance Str
          description: Raw balance of the token as a string
        block_timestamp:
          type: string
          format: date-time
          title: Block Timestamp
          description: Block timestamp (UTC)
        block_number:
          anyOf:
            - type: integer
            - type: 'null'
          title: Block Number
          description: Block number
        block_hash:
          anyOf:
            - type: string
            - type: 'null'
          title: Block Hash
          description: Block hash
      type: object
      required:
        - chain
        - address
        - token
        - raw_balance
        - raw_balance_str
        - block_timestamp
      title: EVMWalletBalances
      examples:
        - address: '0xab16781a13fe343a275f4bb5c883a64ceda52917'
          block_hash: '0x1d8a87d3da939280fe80fff6b90d19ca629726a1e53849766cb82f57d3fdb836'
          block_number: 23145508
          block_timestamp: '2025-08-15T09:22:23Z'
          chain: ethereum
          raw_balance: 1300000000000000000
          raw_balance_str: '1300000000000000000'
          token:
            address: '0x0e7667a943b871835f7399e7a5adb14f70717c7e'
            chain: ethereum
            decimals: 18
            info:
              name: ETH
              symbol: ETH
            object: token
            type: evm_erc20
    SolanaBalances:
      properties:
        chain:
          type: string
          title: Chain
          description: Lowercase chain name
        address:
          $ref: '#/components/schemas/SolanaAddress'
          description: Wallet address
        token:
          $ref: '#/components/schemas/Token'
          description: Token metadata
        raw_balance:
          type: integer
          title: Raw Balance
          description: Raw balance of the token
        raw_balance_str:
          type: string
          title: Raw Balance Str
          description: Raw balance of the token as a string
        block_timestamp:
          type: string
          format: date-time
          title: Block Timestamp
          description: Block timestamp (UTC)
        block_slot:
          type: integer
          title: Block Slot
          description: Block slot
        txn_index:
          type: integer
          title: Txn Index
          description: Transaction index
        token_account:
          anyOf:
            - $ref: '#/components/schemas/SolanaAddress'
            - type: 'null'
          description: Token account
        block_hash:
          type: string
          title: Block Hash
          description: Block hash
        txn_id:
          type: string
          title: Txn Id
          description: Transaction ID
      type: object
      required:
        - chain
        - address
        - token
        - raw_balance
        - raw_balance_str
        - block_timestamp
        - block_slot
        - txn_index
        - token_account
        - block_hash
        - txn_id
      title: SolanaBalances
      examples:
        - address: 125Z6k4ZAxsgdG7JxrKZpwbcS1rxqpAeqM9GSCKd66Wp
          block_hash: GrW5zBwRrfTvLtdJHog7rUMcCPQ9K9AYrMKxDhfuD59A
          block_slot: 387297060
          block_timestamp: '2025-12-17T11:49:10Z'
          chain: solana
          raw_balance: 2985840
          raw_balance_str: '2985840'
          token:
            address: So11111111111111111111111111111111111111111
            chain: solana
            decimals: 9
            object: token
            type: sol_spl
          txn_id: >-
            3dzNgD7ksFoZPeeA14rNN3qxvo5WxsDjTE9VVPj8yLm7y6svTatyrbVTmkJPJErSmhbKLVmJFto1oQsCSVbSeDUT
          txn_index: 714
    BitcoinBalances:
      properties:
        chain:
          type: string
          title: Chain
          description: Lowercase chain name
        address:
          $ref: '#/components/schemas/BitcoinAddress'
          description: Wallet address
        raw_balance:
          type: integer
          title: Raw Balance
          description: Balance in satoshis
        decimals:
          type: integer
          title: Decimals
          description: Token decimal places
        block_timestamp:
          type: string
          format: date-time
          title: Block Timestamp
          description: Block timestamp (UTC)
      type: object
      required:
        - chain
        - address
        - raw_balance
        - decimals
        - block_timestamp
      title: BitcoinBalances
    NearWalletBalances:
      properties:
        chain:
          type: string
          title: Chain
          description: Lowercase chain name
        address:
          $ref: '#/components/schemas/NearAddress'
          description: Wallet address
        token:
          $ref: '#/components/schemas/Token'
          description: Token metadata
        raw_balance:
          type: integer
          title: Raw Balance
          description: Raw balance of the token
        block_timestamp:
          type: string
          format: date-time
          title: Block Timestamp
          description: Block timestamp (UTC)
        block_height:
          anyOf:
            - type: integer
            - type: 'null'
          title: Block Height
          description: Block height
        block_hash:
          anyOf:
            - type: string
            - type: 'null'
          title: Block Hash
          description: Block hash
        account_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Account Id
          description: Near account ID
      type: object
      required:
        - chain
        - address
        - token
        - raw_balance
        - block_timestamp
      title: NearWalletBalances
      examples:
        - account_id: game.hot.tg
          address: i7049047578.tg
          block_hash: 2YhsKKSdEF5XuYByWxowBubG5f3Eew9DK73D6KVvCKdw
          block_height: 179073513
          block_timestamp: '2025-12-31T02:41:02Z'
          chain: near
          raw_balance: 163385104
          token:
            address: game.hot.tg
            chain: near
            object: token
            type: near_nep141
    SuiWalletLatestBalances:
      properties:
        block_timestamp:
          type: string
          format: date-time
          title: Block Timestamp
          description: Block timestamp (UTC)
        address:
          $ref: '#/components/schemas/SuiAddress'
          description: Wallet address
        chain:
          type: string
          title: Chain
          description: Lowercase chain name
        raw_balance:
          type: integer
          title: Raw Balance
          description: Balance in smallest unit
        token:
          $ref: '#/components/schemas/Token'
          description: Token metadata
      type: object
      required:
        - block_timestamp
        - address
        - chain
        - raw_balance
        - token
      title: SuiWalletLatestBalances
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    EVMAddress:
      type: string
    Token:
      properties:
        object:
          type: string
          const: token
          title: Object
          default: token
        chain:
          type: string
          title: Chain
          description: Lowercase chain name
        address:
          type: string
          title: Address
          description: Token contract address
        type:
          anyOf:
            - type: string
              enum:
                - native
                - non_native
                - evm_erc20
                - evm_erc721
                - evm_erc1155
                - sol_spl
                - sui_token
                - near_nep141
                - near_nep245
                - stellar_classic
                - stellar_sac
                - stellar_wasm
            - type: 'null'
          title: Type
          description: >-
            Token standard type: evm_erc20/evm_erc721/evm_erc1155 (EVMs),
            sol_spl (Solana), sui_token (Sui), near_nep141/near_nep245 (Near),
            stellar_classic/stellar_sac/stellar_wasm (Stellar), or native (All)
        price:
          anyOf:
            - type: number
            - type: 'null'
          title: Price
          description: Current price (USD)
        decimals:
          anyOf:
            - type: integer
            - type: 'null'
          title: Decimals
          description: Token decimal places
        info:
          anyOf:
            - $ref: '#/components/schemas/TokenInfo'
            - type: 'null'
          description: Token name and symbol
        attributes:
          anyOf:
            - $ref: '#/components/schemas/TokenAttributes'
            - type: 'null'
          description: Token market attributes
      type: object
      required:
        - chain
        - address
      title: Token
    SolanaAddress:
      type: string
    BitcoinAddress:
      type: string
    NearAddress:
      type: string
    SuiAddress:
      type: string
    TokenInfo:
      properties:
        name:
          type: string
          title: Name
          description: Token name
        symbol:
          type: string
          title: Symbol
          description: Token symbol
      type: object
      required:
        - name
        - symbol
      title: TokenInfo
    TokenAttributes:
      properties:
        total_liquidity_usd:
          anyOf:
            - $ref: '#/components/schemas/LiquidityResults'
            - type: 'null'
          description: >-
            Liquidity data: {'amount': number} when available, or {'details':
            'LIQUIDITY_TOO_HIGH'} when limit exceeded
        price_diff_1d:
          anyOf:
            - type: number
            - type: 'null'
          title: Price Diff 1D
          description: Price change (USD) over last 24h
        price_diff_pct_1d:
          anyOf:
            - type: number
            - type: 'null'
          title: Price Diff Pct 1D
          description: Price change (%) over last 24h
        price_diff_1h:
          anyOf:
            - type: number
            - type: 'null'
          title: Price Diff 1H
          description: Price change (USD) over last 1h
        price_diff_pct_1h:
          anyOf:
            - type: number
            - type: 'null'
          title: Price Diff Pct 1H
          description: Price change (%) over last 1h
        total_supply:
          anyOf:
            - type: number
            - type: 'null'
          title: Total Supply
          description: Total token supply
        fully_diluted_valuation_usd:
          anyOf:
            - type: number
            - type: 'null'
          title: Fully Diluted Valuation Usd
          description: Fully diluted valuation (USD)
        volume_1h:
          anyOf:
            - type: number
            - type: 'null'
          title: Volume 1H
          description: Trading volume over last 1h
        volume_1d:
          anyOf:
            - type: number
            - type: 'null'
          title: Volume 1D
          description: Trading volume over last 24h
        volume_usd_1h:
          anyOf:
            - type: number
            - type: 'null'
          title: Volume Usd 1H
          description: Trading volume (USD) over last 1h
        volume_usd_1d:
          anyOf:
            - type: number
            - type: 'null'
          title: Volume Usd 1D
          description: Trading volume (USD) over last 24h
        volume_24h:
          anyOf:
            - type: number
            - type: 'null'
          title: Volume 24H
          description: Trading volume over last 24h
        volume_usd_24h:
          anyOf:
            - type: number
            - type: 'null'
          title: Volume Usd 24H
          description: Trading volume (USD) over last 24h
        trade_count_1h:
          anyOf:
            - type: integer
            - type: 'null'
          title: Trade Count 1H
          description: Trade count over last 1h
        trade_count_1d:
          anyOf:
            - type: integer
            - type: 'null'
          title: Trade Count 1D
          description: Trade count over last 24h
        all_time_high:
          anyOf:
            - type: number
            - type: 'null'
          title: All Time High
          description: All-time high price (USD)
        all_time_low:
          anyOf:
            - type: number
            - type: 'null'
          title: All Time Low
          description: All-time low price (USD)
        image_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Image Url
          description: Token logo URL
        token_creation_time:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Token Creation Time
          description: Token creation timestamp (UTC)
        holders_count:
          anyOf:
            - type: integer
            - type: 'null'
          title: Holders Count
          description: Number of token holders
        stellar_fields:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Stellar Fields
          description: Stellar-specific metadata
      type: object
      title: TokenAttributes
    LiquidityResults:
      properties:
        amount:
          anyOf:
            - type: number
            - type: 'null'
          title: Amount
          description: Liquidity amount (USD)
        details:
          anyOf:
            - type: string
            - type: 'null'
          title: Details
          description: Status when amount unavailable (e.g. LIQUIDITY_TOO_HIGH)
      type: object
      title: LiquidityResults
  securitySchemes:
    APIKeyBearer:
      type: apiKey
      in: header
      name: X-API-KEY

````